#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
int main(int argc, char **argv){
  int k,n,lecture;
  int tube[2];
  int premier;
  char tampon[32];
  int l=1;
  char  *combien="1000";
  if(argc == 2)
    combien=argv[1];

  if(pipe(tube)==-1){
    perror("creation de tube");
    exit(EXIT_FAILURE);
  }

  if( (k = fork()) == -1){
    perror("premier fork");
    exit(EXIT_FAILURE);
  }

  if( k == 0){ /*fils*/
    close(tube[0]); /*le premier fils ne lit rien*/
    dup2(tube[1],STDOUT_FILENO);
    close(tube[1]);
    execlp("generer","generer",combien,(char *)NULL);
    perror("generer");
    exit(EXIT_FAILURE);
  }
  
  /*pere*/
  for( ;; ){
    close(tube[1]); /*pere n'ecrit rien*/
    n=read(tube[0],&premier,sizeof premier);
    if( n != sizeof premier )
      exit(EXIT_FAILURE);
    
    printf("[%d] %d\n",l++,premier);
    
    lecture = dup(tube[0]);
    if( lecture == -1 ){
      perror("dup");
      exit(EXIT_FAILURE);
    }
    close(tube[0]);
    
    if(pipe(tube)==-1){
      perror("pipe");
      exit(EXIT_FAILURE);
    }
        
    if( (k=fork()) == -1){
      perror("deuxieme fork");
      exit(EXIT_FAILURE);
    }

    if( k == 0){ /*fils*/
      close(tube[0]); /*le premier fils ne lit rien
			dans ce tube*/
      dup2(lecture,STDIN_FILENO);
      close(lecture);
      dup2(tube[1],STDOUT_FILENO);
      close(tube[1]);
      sprintf(tampon,"%d",premier);
      execlp("sito","sito",tampon, (char *)NULL);
      exit(EXIT_FAILURE);
    }
  }
}

